#!/bin/sh
#
# Copyright (c) 2014 IBM Corporation
# All rights reserved.
#

function getPropertyFromFile()
{
	# substitute "." with "\." so that we can use it as sed expression
	propertyName=`echo $1 | sed -e 's/\./\\\./g'`
	fileName=$2;
	cat $fileName | sed -n -e "s/^[ ]*//g;/^#/d;s/^$propertyName.*=//p" | tail -1  | tr -d ' '  | tr -d '"'
}

###################################
# Setup Token Licensing
###################################

fileLocalSetting="/home/${userid}/apphance/project/src/apphance/apphance/local_settings.py"
fileSecuritySetting="/home/${userid}/apphance/project/src/apphance/ibm_license_service/local_ibm_license_settings.py"

licenseServerName=`getPropertyFromFile RCL_SERVER_DOMAIN ${fileSecuritySetting}`
licenseServerPort=`getPropertyFromFile RCL_SERVER_PORT ${fileSecuritySetting}`

counterTL=0
until [ $counterTL != 0 ]; do
	dialog --title "Setup Token Licensing" --clear \
			--yesno "Would you like to enable token licensing?" 10 40
	case $? in
		0)
			counterTL_1=0
			until [ $counterTL_1 != 0 ]; do

				dialog --ok-label "Submit" \
					--title "Setup Token Licensing" \
					--form "License Server information" \
					10 55 0 \
					"Name:" 	1 1 "$licenseServerName"  	  1 8 40 0 \
					"Port:"    	2 1 "$licenseServerPort" 	  2 8 40 0 \
				2>VALUES

				case $? in
					0)
						licenseServerName=`awk 'NR==1' VALUES`
						licenseServerPort=`awk 'NR==2' VALUES`
						rm -f VALUES

						if [ "$licenseServerName" == "" ]
						then
							dialog --msgbox "No name was entered.\n\nPlease try it again." 10 40
						elif [ "$licenseServerPort" == "" ]
						then
							dialog --msgbox "No port was entered.\n\nPlease try it again." 10 40
						else
							dialog --title "Confirm" \
								--yesno "Is the following correct?\n  Name: $licenseServerName\n  Port: $licenseServerPort\n" 10 55

							case $? in
								0)
									sed -ie s/^VALIDATE_TOKENS.*/"VALIDATE_TOKENS = True"/ ${fileLocalSetting}
									sed -ie s/^RCL_SERVER_DOMAIN.*/"RCL_SERVER_DOMAIN = \"${licenseServerName}\""/ ${fileSecuritySetting}
									sed -ie s/^RCL_SERVER_PORT.*/"RCL_SERVER_PORT = ${licenseServerPort}"/ ${fileSecuritySetting}

									dialog --msgbox "Token licensing is now enabled." 10 40

									counterTL_1=1
									counterTL=1
									;;
								1)
									ip=""
									netmask=""
									;;
								255)
									ip=""
									netmask=""
									;;
							esac
						fi
						;;

					# cancel pressed
					1)
						rm -f VALUES
						counterTL_1=1
						;;

					# ESC pressed
					255)
						rm -f VALUES
						counterTL_1=1
						;;
				esac
				

			done
			;;
		1)
			dialog --msgbox "Token licensing is now disabled." 10 40
			sed -ie s/^VALIDATE_TOKENS.*/"VALIDATE_TOKENS = False"/ ${fileLocalSetting}
			counterTL=1
			;;
		255)
			dialog --msgbox "Token licensing is now disabled." 10 40
			sed -ie s/^VALIDATE_TOKENS.*/"VALIDATE_TOKENS = False"/ ${fileLocalSetting}
			counterTL=1
			;;
	esac
done


